searchData={"items":[{"type":"module","doc":"","title":"AshReqOpt","ref":"AshReqOpt.html"},{"type":"extras","doc":"# AshReqOpt\n\nShortcut DSL for attributes and relationships in Ash resources.","title":"AshReqOpt","ref":"readme.html"},{"type":"extras","doc":"| DSL | allow_nil? | public? |\n|:---:|:----------:|:-------:|\n| `attribute` (Ash) | true | false |\n| `req` | false | true |\n| `req_prv` | false | false |\n| `opt` | true | true |\n| `opt_prv` | true | false |","title":"For attribute - AshReqOpt","ref":"readme.html#for-attribute"},{"type":"extras","doc":"| DSL | allow_nil? | public? |\n|:---:|:----------:|:-------:|\n| `belongs_to` (Ash) | true | false |\n| `req_belongs_to` | false | true |\n| `req_prv_belongs_to` | false | false |\n| `opt_belongs_to` | true | true |\n| `opt_prv_belongs_to` | true | false |","title":"For belongs_to - AshReqOpt","ref":"readme.html#for-belongs_to"},{"type":"extras","doc":"```elixir\ndefmodule MyApp.User do\n  use Ash.Resource, extensions: [AshReqOpt]\n\n  attributes do\n    uuid_primary_key :id\n\n    # Required attributes\n    req :email, :string    # allow_nil?: false, public?: true\n    req_prv :password_hash, :string    # allow_nil?: false, public?: false\n\n    # Optional attributes\n    opt :name, :string     # allow_nil?: true, public?: true\n    opt_prv :last_login_at, :utc_datetime  # allow_nil?: true, public?: false\n\n    # Original attribute macro still works\n    attribute :nickname, :string, allow_nil?: true\n  end\n\n  relationships do\n    # Required relationships\n    req_belongs_to :company, Company    # allow_nil?: false, public?: true\n    req_prv_belongs_to :created_by, User    # allow_nil?: false, public?: false\n\n    # Optional relationships\n    opt_belongs_to :manager, User       # allow_nil?: true, public?: true\n    opt_prv_belongs_to :updated_by, User    # allow_nil?: true, public?: false\n\n    # Original belongs_to macro still works\n    belongs_to :department, Department, allow_nil?: true\n  end\nend\n```","title":"Usage Example - AshReqOpt","ref":"readme.html#usage-example"},{"type":"extras","doc":"Add `ash_req_opt` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ash_req_opt, \"~> 0.2.0\"}\n  ]\nend\n```","title":"Installation - AshReqOpt","ref":"readme.html#installation"},{"type":"extras","doc":"MIT","title":"License - AshReqOpt","ref":"readme.html#license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}